--- php-8.4.18/ext/pgsql/pgsql.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/pgsql/pgsql.c	2026-04-01 04:35:36.017319488 +0000
@@ -705,10 +705,12 @@
 			/* create the link */
 			pgsql = PQconnectdb(connstring);
 			if (pgsql == NULL || PQstatus(pgsql) == CONNECTION_BAD) {
-				PHP_PQ_ERROR("Unable to connect to PostgreSQL server: %s", pgsql)
+				zend_string *msgbuf = _php_pgsql_trim_message(PQerrorMessage(pgsql));
 				if (pgsql) {
 					PQfinish(pgsql);
 				}
+				php_error_docref(NULL, E_WARNING, "Unable to connect to PostgreSQL server: %s", ZSTR_VAL(msgbuf));
+				zend_string_release(msgbuf);
 				goto err;
 			}
 
@@ -789,19 +791,23 @@
 		if (connect_type & PGSQL_CONNECT_ASYNC) {
 			pgsql = PQconnectStart(connstring);
 			if (pgsql==NULL || PQstatus(pgsql)==CONNECTION_BAD) {
-				PHP_PQ_ERROR("Unable to connect to PostgreSQL server: %s", pgsql);
+				zend_string *msgbuf = _php_pgsql_trim_message(PQerrorMessage(pgsql));
 				if (pgsql) {
 					PQfinish(pgsql);
 				}
+				php_error_docref(NULL, E_WARNING, "Unable to connect to PostgreSQL server: %s", ZSTR_VAL(msgbuf));
+				zend_string_release(msgbuf);
 				goto err;
 			}
 		} else {
 			pgsql = PQconnectdb(connstring);
 			if (pgsql==NULL || PQstatus(pgsql)==CONNECTION_BAD) {
-				PHP_PQ_ERROR("Unable to connect to PostgreSQL server: %s", pgsql);
+				zend_string *msgbuf = _php_pgsql_trim_message(PQerrorMessage(pgsql));
 				if (pgsql) {
 					PQfinish(pgsql);
 				}
+				php_error_docref(NULL, E_WARNING, "Unable to connect to PostgreSQL server: %s", ZSTR_VAL(msgbuf));
+				zend_string_release(msgbuf);
 				goto err;
 			}
 		}
diff '--color=auto' -Naur php-8.4.18/ext/pgsql/pgsql.stub.php php-8.4.20RC1/ext/pgsql/pgsql.stub.php
--- php-8.4.18/ext/pgsql/pgsql.stub.php	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/pgsql/pgsql.stub.php	2026-04-01 04:35:36.017632730 +0000
@@ -432,7 +432,7 @@
      * @cvalue PGSQL_DML_STRING
      */
     const PGSQL_DML_STRING = UNKNOWN;
-#ifdef PQTRACE_SUPPPRESS_TIMESTAMPS
+#ifdef PQTRACE_SUPPRESS_TIMESTAMPS
     /**
      * @var int
      * @cvalue PQTRACE_SUPPRESS_TIMESTAMPS
diff '--color=auto' -Naur php-8.4.18/ext/pgsql/tests/gh21162.phpt php-8.4.20RC1/ext/pgsql/tests/gh21162.phpt
--- php-8.4.18/ext/pgsql/tests/gh21162.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/pgsql/tests/gh21162.phpt	2026-04-01 04:35:36.017889185 +0000
@@ -0,0 +1,18 @@
+--TEST--
+GH-21162 (pg_connect() on error memory leak)
+--EXTENSIONS--
+pgsql
+--FILE--
+<?php
+
+set_error_handler(function (int $errno, string $errstr) {
+    echo "Warning caught\n";
+});
+
+pg_connect('host=blablahost.');
+
+echo "Done\n";
+?>
+--EXPECT--
+Warning caught
+Done
diff '--color=auto' -Naur php-8.4.18/ext/phar/tests/phar_extract2.phpt php-8.4.20RC1/ext/phar/tests/phar_extract2.phpt
--- php-8.4.18/ext/phar/tests/phar_extract2.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/phar/tests/phar_extract2.phpt	2026-04-01 04:35:36.017981078 +0000
@@ -46,8 +46,6 @@
 @rmdir($dir . 'one/level');
 @rmdir($dir . 'one');
 @rmdir($dir);
-$dir = __DIR__ . '/extract1/';
-@rmdir($dir);
 ?>
 --EXPECTF--
 %sextract2%cfile1.txt
diff '--color=auto' -Naur php-8.4.18/ext/snmp/snmp.c php-8.4.20RC1/ext/snmp/snmp.c
--- php-8.4.18/ext/snmp/snmp.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/snmp/snmp.c	2026-04-01 04:35:36.018113238 +0000
@@ -959,7 +959,7 @@
 /* }}} */
 
 /* {{{ Set the authentication protocol in the snmpv3 session */
-static bool netsnmp_session_set_auth_protocol(struct snmp_session *s, zend_string *prot)
+static ZEND_ATTRIBUTE_NONNULL bool netsnmp_session_set_auth_protocol(struct snmp_session *s, zend_string *prot)
 {
 #ifndef DISABLE_MD5
 	if (zend_string_equals_literal_ci(prot, "MD5")) {
@@ -1011,7 +1011,7 @@
 /* }}} */
 
 /* {{{ Set the security protocol in the snmpv3 session */
-static bool netsnmp_session_set_sec_protocol(struct snmp_session *s, zend_string *prot)
+static ZEND_ATTRIBUTE_NONNULL bool netsnmp_session_set_sec_protocol(struct snmp_session *s, zend_string *prot)
 {
 #ifndef NETSNMP_DISABLE_DES
 	if (zend_string_equals_literal_ci(prot, "DES")) {
@@ -1048,9 +1048,10 @@
 /* }}} */
 
 /* {{{ Make key from pass phrase in the snmpv3 session */
-static bool netsnmp_session_gen_auth_key(struct snmp_session *s, zend_string *pass)
+static ZEND_ATTRIBUTE_NONNULL bool netsnmp_session_gen_auth_key(struct snmp_session *s, zend_string *pass)
 {
 	int snmp_errno;
+
 	s->securityAuthKeyLen = USM_AUTH_KU_LEN;
 	if ((snmp_errno = generate_Ku(s->securityAuthProto, s->securityAuthProtoLen,
 			(uint8_t *) ZSTR_VAL(pass), ZSTR_LEN(pass),
@@ -1063,7 +1064,7 @@
 /* }}} */
 
 /* {{{ Make key from pass phrase in the snmpv3 session */
-static bool netsnmp_session_gen_sec_key(struct snmp_session *s, zend_string *pass)
+static ZEND_ATTRIBUTE_NONNULL bool netsnmp_session_gen_sec_key(struct snmp_session *s, zend_string *pass)
 {
 	int snmp_errno;
 
@@ -1102,9 +1103,10 @@
 /* }}} */
 
 /* {{{ Set all snmpv3-related security options */
-static bool netsnmp_session_set_security(struct snmp_session *session, zend_string *sec_level,
+static ZEND_ATTRIBUTE_NONNULL_ARGS(2) bool netsnmp_session_set_security(struct snmp_session *session, zend_string *sec_level,
 	zend_string *auth_protocol, zend_string *auth_passphrase, zend_string *priv_protocol,
-	zend_string *priv_passphrase, zend_string *contextName, zend_string *contextEngineID)
+	zend_string *priv_passphrase, zend_string *contextName, zend_string *contextEngineID,
+	uint32_t auth_protocol_argnum)
 {
 
 	/* Setting the security level. */
@@ -1115,12 +1117,22 @@
 
 	if (session->securityLevel == SNMP_SEC_LEVEL_AUTHNOPRIV || session->securityLevel == SNMP_SEC_LEVEL_AUTHPRIV) {
 
+		if (!auth_protocol) {
+			zend_argument_value_error(auth_protocol_argnum, "cannot be null when security level is \"authNoPriv\" or \"authPriv\"");
+			return false;
+		}
+
 		/* Setting the authentication protocol. */
 		if (!netsnmp_session_set_auth_protocol(session, auth_protocol)) {
 			/* ValueError already generated, just bail out */
 			return false;
 		}
 
+		if (!auth_passphrase) {
+			zend_argument_value_error(auth_protocol_argnum + 1, "cannot be null when security level is \"authNoPriv\" or \"authPriv\"");
+			return false;
+		}
+
 		/* Setting the authentication passphrase. */
 		if (!netsnmp_session_gen_auth_key(session, auth_passphrase)) {
 			/* Warning message sent already, just bail out */
@@ -1128,12 +1140,23 @@
 		}
 
 		if (session->securityLevel == SNMP_SEC_LEVEL_AUTHPRIV) {
+
+			if (!priv_protocol) {
+				zend_argument_value_error(auth_protocol_argnum + 2, "cannot be null when security level is \"authPriv\"");
+				return false;
+			}
+
 			/* Setting the security protocol. */
 			if (!netsnmp_session_set_sec_protocol(session, priv_protocol)) {
 				/* ValueError already generated, just bail out */
 				return false;
 			}
 
+			if (!priv_passphrase) {
+				zend_argument_value_error(auth_protocol_argnum + 3, "cannot be null when security level is \"authPriv\"");
+				return false;
+			}
+
 			/* Setting the security protocol passphrase. */
 			if (!netsnmp_session_gen_sec_key(session, priv_passphrase)) {
 				/* Warning message sent already, just bail out */
@@ -1294,7 +1317,7 @@
 			netsnmp_session_free(&session);
 			RETURN_FALSE;
 		}
-		if (version == SNMP_VERSION_3 && !netsnmp_session_set_security(session, a3, a4, a5, a6, a7, NULL, NULL)) {
+		if (version == SNMP_VERSION_3 && !netsnmp_session_set_security(session, a3, a4, a5, a6, a7, NULL, NULL, 4)) {
 			php_free_objid_query(&objid_query, oid_ht, value_ht, st);
 			netsnmp_session_free(&session);
 			/* Warning message sent already, just bail out */
@@ -1669,7 +1692,7 @@
 		RETURN_THROWS();
 	}
 
-	if (!netsnmp_session_set_security(snmp_object->session, a1, a2, a3, a4, a5, a6, a7)) {
+	if (!netsnmp_session_set_security(snmp_object->session, a1, a2, a3, a4, a5, a6, a7, 2)) {
 		/* Warning message sent already, just bail out */
 		RETURN_FALSE;
 	}
diff '--color=auto' -Naur php-8.4.18/ext/snmp/tests/gh21336.phpt php-8.4.20RC1/ext/snmp/tests/gh21336.phpt
--- php-8.4.18/ext/snmp/tests/gh21336.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/snmp/tests/gh21336.phpt	2026-04-01 04:35:36.018298959 +0000
@@ -0,0 +1,41 @@
+--TEST--
+GH-21336 (undefined behavior in snmp - NULL pointer dereference in setSecurity)
+--EXTENSIONS--
+snmp
+--FILE--
+<?php
+$session = new SNMP(SNMP::VERSION_3, 'localhost', 'user');
+
+// auth protocol NULL
+try {
+	$session->setSecurity('authPriv');
+} catch (ValueError $e) {
+	echo $e->getMessage() . PHP_EOL;
+}
+
+// auth passphrase NULL
+try {
+	$session->setSecurity('authNoPriv', 'MD5');
+} catch (ValueError $e) {
+	echo $e->getMessage() . PHP_EOL;
+}
+
+// priv protocol NULL
+try {
+	$session->setSecurity('authPriv', 'MD5', 'test12345');
+} catch (ValueError $e) {
+	echo $e->getMessage() . PHP_EOL;
+}
+
+// priv passphrase NULL
+try {
+	$session->setSecurity('authPriv', 'MD5', 'test12345', 'AES');
+} catch (ValueError $e) {
+	echo $e->getMessage() . PHP_EOL;
+}
+?>
+--EXPECT--
+SNMP::setSecurity(): Argument #2 ($authProtocol) cannot be null when security level is "authNoPriv" or "authPriv"
+SNMP::setSecurity(): Argument #3 ($authPassphrase) cannot be null when security level is "authNoPriv" or "authPriv"
+SNMP::setSecurity(): Argument #4 ($privacyProtocol) cannot be null when security level is "authPriv"
+SNMP::setSecurity(): Argument #5 ($privacyPassphrase) cannot be null when security level is "authPriv"
diff '--color=auto' -Naur php-8.4.18/ext/soap/php_encoding.c php-8.4.20RC1/ext/soap/php_encoding.c
--- php-8.4.18/ext/soap/php_encoding.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/soap/php_encoding.c	2026-04-01 04:35:36.018495951 +0000
@@ -2534,19 +2534,20 @@
 		xmlNsPtr nsptr;
 
 		parse_namespace(attr->children->content, &type, &ns);
+		char *type_dup = estrdup(type);
 		nsptr = xmlSearchNs(attr->doc, attr->parent, BAD_CAST(ns));
 
-		end = strrchr(type,'[');
+		end = strrchr(type_dup,'[');
 		if (end) {
 			*end = '\0';
 			dimension = calc_dimension(end+1);
 			dims = get_position(dimension, end+1);
 		}
 		if (nsptr != NULL) {
-			enc = get_encoder(SOAP_GLOBAL(sdl), (char*)nsptr->href, type);
+			enc = get_encoder(SOAP_GLOBAL(sdl), (char*)nsptr->href, type_dup);
 		}
 		if (ns) {efree(ns);}
-
+		if (type_dup) efree(type_dup);
 	} else if ((attr = get_attribute(data->properties,"itemType")) &&
 	    attr->children &&
 	    attr->children->content) {
diff '--color=auto' -Naur php-8.4.18/ext/soap/php_http.c php-8.4.20RC1/ext/soap/php_http.c
--- php-8.4.18/ext/soap/php_http.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/soap/php_http.c	2026-04-01 04:35:36.018754620 +0000
@@ -1010,23 +1010,23 @@
 		char *sempos = strstr(cookie, ";");
 		if (eqpos != NULL && (sempos == NULL || sempos > eqpos)) {
 			smart_str name = {0};
-			int cookie_len;
 			zval zcookie;
+			size_t cookie_value_len;
 
 			if (sempos != NULL) {
-				cookie_len = sempos-(eqpos+1);
+				cookie_value_len = sempos-(eqpos+1);
 			} else {
-				cookie_len = strlen(cookie)-(eqpos-cookie)-1;
+				cookie_value_len = strlen(cookie)-(eqpos-cookie)-1;
 			}
 
 			smart_str_appendl(&name, cookie, eqpos - cookie);
 			smart_str_0(&name);
 
 			array_init(&zcookie);
-			add_index_stringl(&zcookie, 0, eqpos + 1, cookie_len);
+			add_index_stringl(&zcookie, 0, eqpos + 1, cookie_value_len);
 
 			if (sempos != NULL) {
-				char *options = cookie + cookie_len+1;
+				char *options = sempos + 1;
 				while (*options) {
 					while (*options == ' ') {options++;}
 					sempos = strstr(options, ";");
diff '--color=auto' -Naur php-8.4.18/ext/soap/tests/bugs/cookie_parse_options_offset.phpt php-8.4.20RC1/ext/soap/tests/bugs/cookie_parse_options_offset.phpt
--- php-8.4.18/ext/soap/tests/bugs/cookie_parse_options_offset.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/soap/tests/bugs/cookie_parse_options_offset.phpt	2026-04-01 04:35:36.018924401 +0000
@@ -0,0 +1,61 @@
+--TEST--
+SOAP Set-Cookie option parsing starts at wrong offset due to variable shadowing
+--EXTENSIONS--
+soap
+--SKIPIF--
+<?php
+if (!file_exists(__DIR__ . "/../../../../sapi/cli/tests/php_cli_server.inc")) {
+    echo "skip sapi/cli/tests/php_cli_server.inc required but not found";
+}
+?>
+--FILE--
+<?php
+
+include __DIR__ . "/../../../../sapi/cli/tests/php_cli_server.inc";
+
+$args = ["-d", "extension_dir=" . ini_get("extension_dir"), "-d", "extension=" . (substr(PHP_OS, 0, 3) == "WIN" ? "php_" : "") . "soap." . PHP_SHLIB_SUFFIX];
+if (php_ini_loaded_file()) {
+    $args[] = "-c";
+    $args[] = php_ini_loaded_file();
+}
+
+// A 10-char name makes the wrong offset land exactly on the value "path=/evil",
+// falsely matching it as a path attribute.
+$code = <<<'PHP'
+header("Content-Type: text/xml");
+header("Set-Cookie: sessionkey=path=/evil;domain=good.com");
+echo <<<XML
+<?xml version="1.0" encoding="UTF-8"?>
+<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ns1="test-uri">
+  <SOAP-ENV:Body>
+    <ns1:testResponse/>
+  </SOAP-ENV:Body>
+</SOAP-ENV:Envelope>
+XML;
+PHP;
+
+php_cli_server_start($code, null, $args);
+
+$client = new SoapClient(null, [
+    'location' => 'http://' . PHP_CLI_SERVER_ADDRESS . '/test/endpoint',
+    'uri' => 'test-uri',
+    'trace' => true,
+]);
+
+try {
+    $client->__soapCall("test", []);
+} catch (SoapFault $e) {
+    // Response parsing may fault, cookies are still stored
+}
+
+$cookies = $client->__getCookies();
+
+// path should default to "/test" from the request URI, not "/evil" from the value.
+echo "value: " . $cookies['sessionkey'][0] . "\n";
+echo "path: " . $cookies['sessionkey'][1] . "\n";
+echo "domain: " . $cookies['sessionkey'][2] . "\n";
+?>
+--EXPECT--
+value: path=/evil
+path: /test
+domain: good.com
diff '--color=auto' -Naur php-8.4.18/ext/soap/tests/soap_qname_crash.phpt php-8.4.20RC1/ext/soap/tests/soap_qname_crash.phpt
--- php-8.4.18/ext/soap/tests/soap_qname_crash.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/soap/tests/soap_qname_crash.phpt	2026-04-01 04:35:36.019019981 +0000
@@ -4,6 +4,7 @@
 soap
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (PHP_INT_SIZE != 8) die("skip: 64-bit only");
 ?>
 --INI--
diff '--color=auto' -Naur php-8.4.18/ext/sockets/conversions.c php-8.4.20RC1/ext/sockets/conversions.c
--- php-8.4.18/ext/sockets/conversions.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/sockets/conversions.c	2026-04-01 04:35:36.019127645 +0000
@@ -611,7 +611,7 @@
 	} else {
 		/* error already emitted, but let's emit another more relevant */
 		do_from_zval_err(ctx, "could not resolve address '%s' to get an AF_INET6 "
-				"address", Z_STRVAL_P(zaddr_str));
+				"address", ZSTR_VAL(addr_str));
 	}
 
 	zend_tmp_string_release(tmp_addr_str);
diff '--color=auto' -Naur php-8.4.18/ext/sockets/sockets.c php-8.4.20RC1/ext/sockets/sockets.c
--- php-8.4.18/ext/sockets/sockets.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/sockets/sockets.c	2026-04-01 04:35:36.019294059 +0000
@@ -1584,6 +1584,12 @@
 	switch (php_sock->type) {
 		case AF_UNIX:
 			memset(&s_un, 0, sizeof(s_un));
+
+			if (addr_len >= sizeof(s_un.sun_path)) {
+				zend_argument_value_error(5, "must be less than %d", sizeof(s_un.sun_path));
+				RETURN_THROWS();
+			}
+
 			s_un.sun_family = AF_UNIX;
 			snprintf(s_un.sun_path, sizeof(s_un.sun_path), "%s", addr);
 
diff '--color=auto' -Naur php-8.4.18/ext/sockets/tests/gh21161.phpt php-8.4.20RC1/ext/sockets/tests/gh21161.phpt
--- php-8.4.18/ext/sockets/tests/gh21161.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/sockets/tests/gh21161.phpt	2026-04-01 04:35:36.019484379 +0000
@@ -0,0 +1,19 @@
+--TEST--
+GH-21161 (IPV6_PKTINFO socket option crash with null addr array entry)
+--EXTENSIONS--
+sockets
+--SKIPIF--
+<?php
+if (substr(PHP_OS, 0, 3) == 'WIN') {
+    die('skip.. Not valid for Windows');
+}
+?>
+--FILE--
+<?php
+$sock = socket_create(AF_INET6, SOCK_DGRAM, 0);
+socket_set_option($sock, IPPROTO_IPV6, IPV6_PKTINFO, ['addr' => null, 'ifindex' => 0]);
+?>
+--EXPECTF--
+Warning: socket_set_option(): Host lookup failed [%i]: %s on line %d
+
+Warning: socket_set_option(): error converting user data (path: in6_pktinfo > addr): could not resolve address '' to get an AF_INET6 address in %s on line %d
diff '--color=auto' -Naur php-8.4.18/ext/sockets/tests/socket_sendto_unix_addr_too_long.phpt php-8.4.20RC1/ext/sockets/tests/socket_sendto_unix_addr_too_long.phpt
--- php-8.4.18/ext/sockets/tests/socket_sendto_unix_addr_too_long.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/sockets/tests/socket_sendto_unix_addr_too_long.phpt	2026-04-01 04:35:36.019552277 +0000
@@ -0,0 +1,29 @@
+--TEST--
+socket_sendto() with AF_UNIX rejects address exceeding sun_path limit
+--EXTENSIONS--
+sockets
+--SKIPIF--
+<?php
+if (substr(PHP_OS, 0, 3) == 'WIN') {
+    die('skip not valid for Windows');
+}
+?>
+--FILE--
+<?php
+$socket = socket_create(AF_UNIX, SOCK_DGRAM, 0);
+if (!$socket) {
+    die('Unable to create AF_UNIX socket');
+}
+
+$long_addr = str_repeat('a', 512);
+
+try {
+    socket_sendto($socket, "data", 4, 0, $long_addr);
+} catch (\ValueError $e) {
+    echo $e->getMessage() . PHP_EOL;
+}
+
+socket_close($socket);
+?>
+--EXPECTF--
+socket_sendto(): Argument #5 ($address) must be less than %d
diff '--color=auto' -Naur php-8.4.18/ext/spl/spl_heap.c php-8.4.20RC1/ext/spl/spl_heap.c
--- php-8.4.18/ext/spl/spl_heap.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/spl/spl_heap.c	2026-04-01 04:35:36.019681081 +0000
@@ -961,7 +961,7 @@
 {
 	spl_heap_object *object = Z_SPLHEAP_P(&iter->data);
 
-	if (UNEXPECTED(spl_heap_consistency_validations(object, false) != SUCCESS)) {
+	if (UNEXPECTED(spl_heap_consistency_validations(object, true) != SUCCESS)) {
 		return;
 	}
 
@@ -992,6 +992,10 @@
 		RETURN_THROWS();
 	}
 
+	if (UNEXPECTED(spl_heap_consistency_validations(intern, true) != SUCCESS)) {
+		RETURN_THROWS();
+	}
+
 	spl_ptr_heap_delete_top(intern->heap, NULL, ZEND_THIS);
 }
 /* }}} */
diff '--color=auto' -Naur php-8.4.18/ext/spl/tests/heap_next_write_lock.phpt php-8.4.20RC1/ext/spl/tests/heap_next_write_lock.phpt
--- php-8.4.18/ext/spl/tests/heap_next_write_lock.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/spl/tests/heap_next_write_lock.phpt	2026-04-01 04:35:36.019808051 +0000
@@ -0,0 +1,34 @@
+--TEST--
+SplHeap::next() write lock
+--CREDITS--
+cnitlrt
+--FILE--
+<?php
+
+class EvilPQ extends SplPriorityQueue {
+    private bool $did = false;
+
+    public function compare(mixed $p1, mixed $p2): int {
+        if (!$this->did) {
+            $this->did = true;
+            // Re-entrant write during internal heap insertion comparison.
+            if (!$this->isEmpty()) {
+                $this->next(); // no write-lock validation
+            }
+        }
+        return parent::compare($p1, $p2);
+    }
+}
+
+$q = new EvilPQ();
+try {
+    for ($i = 0; $i < 200; $i++) {
+        $q->insert("d$i", 100 - $i);
+    }
+} catch (RuntimeException $e) {
+    echo $e::class, ": ", $e->getMessage(), "\n";
+}
+
+?>
+--EXPECT--
+RuntimeException: Heap cannot be changed when it is already being modified.
diff '--color=auto' -Naur php-8.4.18/ext/standard/basic_functions.c php-8.4.20RC1/ext/standard/basic_functions.c
--- php-8.4.18/ext/standard/basic_functions.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/basic_functions.c	2026-04-01 04:35:36.019945510 +0000
@@ -1768,7 +1768,10 @@
 	}
 
 	if (i) {
-		php_output_start_default();
+		if (UNEXPECTED(php_output_start_default() != SUCCESS)) {
+			zend_throw_error(NULL, "Unable to start output handler");
+			RETURN_THROWS();
+		}
 	}
 
 	php_get_highlight_struct(&syntax_highlighter_ini);
@@ -1803,7 +1806,10 @@
 		Z_PARAM_PATH_STR(filename)
 	ZEND_PARSE_PARAMETERS_END();
 
-	php_output_start_default();
+	if (UNEXPECTED(php_output_start_default() != SUCCESS)) {
+		zend_throw_error(NULL, "Unable to start output handler");
+		RETURN_THROWS();
+	}
 
 	zend_stream_init_filename_ex(&file_handle, filename);
 	zend_save_lexical_state(&original_lex_state);
@@ -1840,7 +1846,10 @@
 	ZEND_PARSE_PARAMETERS_END();
 
 	if (i) {
-		php_output_start_default();
+		if (UNEXPECTED(php_output_start_default() != SUCCESS)) {
+			zend_throw_error(NULL, "Unable to start output handler");
+			RETURN_THROWS();
+		}
 	}
 
 	EG(error_reporting) = E_ERROR;
diff '--color=auto' -Naur php-8.4.18/ext/standard/exec.c php-8.4.20RC1/ext/standard/exec.c
--- php-8.4.18/ext/standard/exec.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/exec.c	2026-04-01 04:35:36.020108188 +0000
@@ -282,7 +282,7 @@
 	size_t x, y;
 	zend_string *cmd;
 #ifndef PHP_WIN32
-	char *p = NULL;
+	const char *p = NULL;
 #endif
 
 	ZEND_ASSERT(ZSTR_LEN(unescaped_cmd) == strlen(ZSTR_VAL(unescaped_cmd)) && "Must be a binary safe string");
diff '--color=auto' -Naur php-8.4.18/ext/standard/filters.c php-8.4.20RC1/ext/standard/filters.c
--- php-8.4.18/ext/standard/filters.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/filters.c	2026-04-01 04:35:36.020229847 +0000
@@ -1559,7 +1559,7 @@
 	php_convert_filter *inst;
 	php_stream_filter *retval = NULL;
 
-	char *dot;
+	const char *dot;
 	int conv_mode = 0;
 
 	if (filterparams != NULL && Z_TYPE_P(filterparams) != IS_ARRAY) {
diff '--color=auto' -Naur php-8.4.18/ext/standard/libavifinfo/avifinfo.c php-8.4.20RC1/ext/standard/libavifinfo/avifinfo.c
